config/routes.rb
Rails.application.routes.draw do
  resources :salary_ranges
  resources :hobbies
  resources :hobbies
  resources :jobs
  resources :personal_infos
  resources :people
  resources :people

  root'people#index'

end

app/models/person.rb
class Person < ActiveRecord::Base
  has_many :jobs
  has_one :personal_info
  validates :login, uniqueness: true
  has_and_belongs_to_many :hobbies
  has_many :approx_salaries, through: :jobs, source: :salary_range
  depend: :destroy
  scope :starts_with, -> (starting_string){
    where("first_name LIKE ?","#{starting_string}%")
   }

end

app/controllers/people_controller.rb
class PeopleController < ApplicationController
  before_action :set_person, only: [:show, :edit, :update, :destroy]

  # GET /people
  # GET /people.json
  def index
    @people = Person.all
    @people = @people.starts_with(params[:search]) if params[:search].present?
  end

  # GET /people/1
  # GET /people/1.json
  def show
  end

  # GET /people/new
  def new
    @person = Person.new
  end

  # GET /people/1/edit
  def edit
  end

  # POST /people
  # POST /people.json
  def create
    @person = Person.new(person_params)

    respond_to do |format|
      if @person.save
        format.html { redirect_to @person, notice: 'Person was successfully created.' }
        format.json { render :show, status: :created, location: @person }
      else
        format.html { render :new }
        format.json { render json: @person.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /people/1
  # PATCH/PUT /people/1.json
  def update
    respond_to do |format|
      if @person.update(person_params)
        format.html { redirect_to @person, notice: 'Person was successfully updated.' }
        format.json { render :show, status: :ok, location: @person }
      else
        format.html { render :edit }
        format.json { render json: @person.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /people/1
  # DELETE /people/1.json
  def destroy
    @person.destroy
    respond_to do |format|
      format.html { redirect_to people_url, notice: 'Person was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_person
      @person = Person.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def person_params
      params.require(:person).permit(:first_name, :last_name, :age, :login, :password)
    end
end

app/helpers/people_helper.rb
module PeopleHelper
end

app/views/people/_form.html.erb
<%= form_for(@person) do |f| %>
  <% if @person.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@person.errors.count, "error") %> prohibited this person from being saved:</h2>

      <ul>
      <% @person.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :first_name %><br>
    <%= f.text_field :first_name %>
  </div>
  <div class="field">
    <%= f.label :last_name %><br>
    <%= f.text_field :last_name %>
  </div>
  <div class="field">
    <%= f.label :age %><br>
    <%= f.number_field :age %>
  </div>
  <div class="field">
    <%= f.label :login %><br>
    <%= f.text_field :login %>
  </div>
  <div class="field">
    <%= f.label :password %><br>
    <%= f.text_field :password %>
  </div>
  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/people/edit.html.erb
<h1>Editing Person</h1>

<%= render 'form' %>

<%= link_to 'Show', @person %> |
<%= link_to 'Back', people_path %>

app/views/people/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Listing People</h1>

<table>
  <thead>
    <tr>
      <th>First name</th>
      <th>Last name</th>
      <th>Age</th>
      <th>Login</th>
      <th>Password</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @people.each do |person| %>
      <tr>
        <td><%= person.first_name %></td>
        <td><%= person.last_name %></td>
        <td><%= person.age %></td>
        <td><%= person.login %></td>
        <td><%= person.password %></td>
        <% person.hobbies.each do |t|  %>

          <td>
            <%= t.name %>
          </td>

      <%  end %>

      <% person.approx_salaries.each do |y| %>

      <td>
        <%= y.min_salary %>
      </td>

      <% end %>

        <td><%= link_to 'Show', person %></td>
        <td><%= link_to 'Edit', edit_person_path(person) %></td>
        <td><%= link_to 'Destroy', person, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<%= form_tag(people_path, :method => "get", id: "search-form") do %>
<%= text_field_tag :search, params[:search], placeholder: "Search People" %>
<%= submit_tag "Search" %>
<% end %>

<br>

<%= link_to 'New Person', new_person_path %>

app/views/people/new.html.erb
<h1>New Person</h1>

<%= render 'form' %>

<%= link_to 'Back', people_path %>

app/views/people/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>First name:</strong>
  <%= @person.first_name %>
</p>

<p>
  <strong>Last name:</strong>
  <%= @person.last_name %>
</p>

<p>
  <strong>Age:</strong>
  <%= @person.age %>
</p>

<p>
  <strong>Login:</strong>
  <%= @person.login %>
</p>

<p>
  <strong>Password:</strong>
  <%= @person.password %>
</p>

<%= link_to 'Edit', edit_person_path(@person) %> |
<%= link_to 'Back', people_path %>